"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Evaluation(ProtocolElement):
    """
    Evaluation ========================================
    reportedVsGeneticSummary: familyPassesGvsRChecks,
    familyFailsACheck, familyMissingACheck
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_11 import metrics as metrics_1_2_2

        return {
            "coverageBasedSexCheck": metrics_1_2_2.CoverageBasedSexCheck,
            "familyRelatednessCheck": metrics_1_2_2.FamilyRelatednessCheck,
            "mendelianInconsistenciesCheck": metrics_1_2_2.MendelianInconsistenciesCheck,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_11 import metrics as metrics_1_2_2

        return {
            "reportedVsGeneticSummary": metrics_1_2_2.reportedVsGeneticSummary,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_11 import metrics as metrics_1_2_2

        return {
            "org.gel.models.metrics.avro.CoverageBasedSexCheck": metrics_1_2_2.CoverageBasedSexCheck,
            "org.gel.models.metrics.avro.FamilyRelatednessCheck": metrics_1_2_2.FamilyRelatednessCheck,
            "org.gel.models.metrics.avro.MendelianInconsistenciesCheck": metrics_1_2_2.MendelianInconsistenciesCheck,
            "org.gel.models.metrics.avro.reportedVsGeneticSummary": metrics_1_2_2.reportedVsGeneticSummary,
            "org.gel.models.metrics.avro.Evaluation": metrics_1_2_2.Evaluation,
        }

    __slots__ = [
        "coverageBasedSexCheck",
        "familyRelatednessCheck",
        "mendelianInconsistenciesCheck",
        "reportedVsGeneticSummary",
    ]

    def __init__(
        self,
        coverageBasedSexCheck=None,
        familyRelatednessCheck=None,
        mendelianInconsistenciesCheck=None,
        reportedVsGeneticSummary=None,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_2.Evaluation model.

        :param coverageBasedSexCheck:
            Coverage-based sex evaluation. One entry per sample
        :type coverageBasedSexCheck: None | list[CoverageBasedSexCheck]
        :param familyRelatednessCheck:
            Within-family relatedness evaluation. One entry per pair of samples
        :type familyRelatednessCheck: None | list[FamilyRelatednessCheck]
        :param mendelianInconsistenciesCheck:
            Mendelian inconsitencies evaluation. One entry per sample
        :type mendelianInconsistenciesCheck: None | list[MendelianInconsistenciesCheck]
        :param reportedVsGeneticSummary:
            Final evaluation summary. Does the family passes RvsG checks or errors
            are present?
        :type reportedVsGeneticSummary: None | reportedVsGeneticSummary
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.2"
